<?
/**
 * class PDF extends FPDF : FPDF/tutoriel/tuto6.htm
 */
class PDF extends FPDF
{
var $B;
var $I;
var $U;
var $HREF;

function PDF($orientation='P',$unit='mm',$format='A4')
{
	//Appel au constructeur parent
	$this->FPDF($orientation,$unit,$format);
	//Initialisation
	$this->B=0;
	$this->I=0;
	$this->U=0;
	$this->HREF='';
}

function WriteHTML($html)
{
	//Parseur HTML
	$html=str_replace("\n",' ',$html);
	$a=preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);
	foreach($a as $i=>$e)
	{
		if($i%2==0)
		{
			//Texte
			if($this->HREF)
				$this->PutLink($this->HREF,$e);
			else
				$this->Write(5,$e);
		}
		else
		{
			//Balise
			if($e{0}=='/')
				$this->CloseTag(strtoupper(substr($e,1)));
			else
			{
				//Extraction des proprits
				$a2=split(' ',$e);
				$tag=strtoupper(array_shift($a2));
				$prop=array();
				foreach($a2 as $v)
					if(ereg('^([^=]*)=["\']?([^"\']*)["\']?$',$v,$a3))
						$prop[strtoupper($a3[1])]=$a3[2];
				$this->OpenTag($tag,$prop);
			}
		}
	}
}

function OpenTag($tag,$prop)
{
	//Balise ouvrante
	if($tag=='B' or $tag=='I' or $tag=='U'){
		$this->SetStyle($tag,true);
	}
	
	if($tag=='A'){
		$this->HREF=$prop['HREF'];
	}
	
	if($tag=='BR'){
		$this->Ln(5);
	}
	
	if($tag=='P'){
		$this->Ln(5);
	}
	
	if($tag=='H3'){
			
		$this->Ln(15);
		// $this->$align = "C";
		$this->SetStyle($tag='B',true,'14');
	}
	
	if($tag=='UL') {
		$this->SetLeftMargin($this->lMargin+10); 
		if($tag=='LI'){ 
			$this->Ln(); 
			$this->SetX($this->GetX()-10); 
			$this->Cell(10,5,chr(149),0,0,'C'); 
		}
	}
}

function CloseTag($tag)
{
	//Balise fermante
	if($tag=='B' or $tag=='I' or $tag=='U'){
		$this->SetStyle($tag,false);
	}
		
	if($tag=='A'){
		$this->HREF='';
	}
		
	if($tag=='P'){
		$this->Ln(5);
	}
	
	if($tag=='H3'){		
		$this->SetStyle($tag='B',false,'12');
		$this->Ln(5);
	}
	
	if($tag=='UL') { 
		$this->SetLeftMargin($this->lMargin-10); 
		$this->Ln(); 
	} 
}

function SetStyle($tag,$enable,$size='')
{
	//Modifie le style et slectionne la police correspondante
	$this->$tag+=($enable ? 1 : -1);
	$style='';
	foreach(array('B','I','U') as $s)
		if($this->$s>0)
			$style.=$s;
	$this->SetFont('',$style,$size);
}

function PutLink($URL,$txt)
{
	//Place un hyperlien
	$this->SetTextColor(0,0,255);
	$this->SetStyle('U',true);
	$this->Write(5,$txt,$URL);
	$this->SetStyle('U',false);
	$this->SetTextColor(0);
}
}

?>